package encap_test

import (
	"fmt"
	"testing"
	"unsafe"
)

type Employee struct {
	Id   string
	Name string
	Age  int
}

// 指针形式 复用  推荐使用
func (e *Employee) String() string {
	fmt.Printf("Address is %x \n", unsafe.Pointer(&e.Name))
	return fmt.Sprintf("Id: %s, Name: %s, Age: %d", e.Id, e.Name, e.Age)
}

// 数据复制, 地址变了
// func (e Employee) String() string {
// 	fmt.Printf("Address is %x \n", unsafe.Pointer(&e.Name))
// 	return fmt.Sprintf("Id: %s, Name: %s, Age: %d", e.Id, e.Name, e.Age)
// }

func TestCreateEmployeeObj(t *testing.T) {
	e := Employee{"1", "Frank", 20}
	e1 := Employee{Name: "Mike", Age: 28}
	e2 := new(Employee) //返回指针
	e2.Id = "3"
	e2.Name = "Jack"
	e2.Age = 32

	t.Log(e)
	t.Log(e1)
	t.Log(e1.Id) //空字符串
	t.Log(e2)

	t.Logf("e is %T", e)
	t.Logf("e2 is %T", e2)
}

func TestStructOperations(t *testing.T) {
	e := Employee{"1", "Frank", 20}
	fmt.Printf("Address is %x \n", unsafe.Pointer(&e.Name))
	t.Log(e.String())
}
