package polymorphism

import (
	"fmt"
	"testing"
)

// 多态

type Code string

type Programmer interface {
	WriteHelloWorld() Code
}

type GoProgrammer struct {
}

func (gp *GoProgrammer) WriteHelloWorld() Code {
	return "fmt.Println(\"hello world\")"
}

type JavaProgrammer struct {
}

func (jp *JavaProgrammer) WriteHelloWorld() Code {
	return "System.out.Println(\"hello world\")"
}

func writeFirstProgram(p Programmer) {
	// %T 输出类型
	fmt.Printf("%T %v\n", p, p.WriteHelloWorld())
}

func TestPolymorphism(t *testing.T) {
	gp := new(GoProgrammer)
	// gp := &GoProgrammer{}
	jp := new(JavaProgrammer)
	writeFirstProgram(gp)
	writeFirstProgram(jp)
}
