package panic_recover

import (
	"errors"
	"fmt"
	"testing"
)

// Let it Crash 往往是恢复不确定性错误的最好方法
// panic 用于不可以恢复的错误
// panic 退出前会执行 defer 指定的内容

// os.Exit 退出时不会调用 defer 指定的函数
// os.Exit 退出时不输出当前调用栈信息

// 常见的错误恢复 recover()
// 当心 recover 成为"恶魔" 形成僵尸服务进程 导致health check失效

func TestPanicVxExit(t *testing.T) {
	// defer func ()  {
	// 	fmt.Println("Finally")
	// }()

	defer func() {
		// recover() 错误恢复 小心使用
		if err := recover(); err != nil {
			fmt.Println("recovered from ", err)
		}
	}()
	fmt.Println("Start")
	panic(errors.New("Something wrong!"))
	// os.Exit(-1)
	// fmt.Println("end")
}
