package csp_test

import (
	"fmt"
	"testing"
	"time"
)

func service() string {
	time.Sleep(time.Millisecond * 50)
	return "Done"
}

func otherTask() {
	fmt.Println("执行一些其他的任务")
	time.Sleep(time.Millisecond * 100)
	fmt.Println("任务完成")
}

func TestService(t *testing.T) {
	fmt.Println(service())
	otherTask()
}

func AsyncService() chan string {
	retChan := make(chan string, 1) // buffered channel (非阻塞、异步模式) 不会阻塞service
	// retChan := make(chan string)  // unbuffered channel (阻塞、同步模式) 会阻塞service
	go func() {
		ret := service()
		fmt.Println("返回service结果")
		retChan <- ret
		fmt.Println("service已退出")
	}()
	return retChan
}

func TestAsyncService(t *testing.T) {
	retCh := AsyncService()
	otherTask()
	fmt.Println(<-retCh)
}
