package select_test

import (
	"fmt"
	"testing"
	"time"
)

func service() string {
	time.Sleep(time.Millisecond * 100)
	return "Done"
}

func AsyncService() chan string {
	retChan := make(chan string, 1) // buffered channel (非阻塞、异步模式) 不会阻塞service
	// retChan := make(chan string)  // unbuffered channel (阻塞、同步模式) 会阻塞service
	go func() {
		ret := service()
		fmt.Println("返回service结果")
		retChan <- ret
		fmt.Println("service已退出")
	}()
	return retChan
}

// 多路选择 select 实现超时机制
func TestSelect(t *testing.T) {
	select {
	case ret := <-AsyncService():
		t.Log(ret)
	case <-time.After(time.Millisecond * 100):
		t.Error("超时")
	}
}
