package once_test

import (
	"fmt"
	"sync"
	"testing"
	"unsafe"
)

// 利用sync.Once实现 单例模式

type Singleton struct {
}

var singletonInstance *Singleton
var once sync.Once

func GetSingletonObj() *Singleton {
	once.Do(func() {
		fmt.Println("创建对象")
		singletonInstance = new(Singleton)
	})
	return singletonInstance
}

func TestGetSingletonObj(t *testing.T) {
	var wg sync.WaitGroup
	for i := 0; i < 10; i++ {
		wg.Add(1)
		go func() {
			obj := GetSingletonObj()
			t.Logf("%x", unsafe.Pointer(obj))
			wg.Done()
		}()
	}
	wg.Wait()
}
