package unit_test

import (
	"fmt"
	"testing"

	"github.com/go-playground/assert/v2"
)

// 表格测试法
func TestSquare(t *testing.T) {
	// 输入值
	inputs := [...]int{1, 2, 3}
	// 期待值
	expected := [...]int{1, 4, 9}
	for i := 0; i < len(inputs); i++ {
		ret := Square(inputs[i])
		if ret != expected[i] {
			t.Errorf("input is %d, the expected is %d, the actual %d", inputs[i], expected[i], ret)
		}
	}
}

func TestErrorInCode(t *testing.T) {
	fmt.Println("Start")
	t.Error("Error") // 程序继续执行
	fmt.Println("End")
}

func TestFatalInCode(t *testing.T) {
	fmt.Println("Start")
	t.Fatal("Error") // 程序会中断 不会输出End
	fmt.Println("End")
}

// 使用断言Assert测试
func TestSquareWithAssert(t *testing.T) {
	// 输入值
	inputs := [...]int{1, 2, 3}
	// 期待值
	expected := [...]int{1, 4, 9}
	for i := 0; i < len(inputs); i++ {
		ret := Square(inputs[i])
		assert.Equal(t, expected[i], ret)
	}
}
