package tpye_test

import (
	"math"
	"testing"
)

// 自定义类型
type MyInt int64

// 类型转换
func TestImplicit(t *testing.T) {
	var a int32 = 1
	// 显示类型转换
	var b = int64(a)
	var c = MyInt(b)
	t.Log(a, b, c)
}

// 指针
func TestPoint(t *testing.T) {
	a := 1
	aPtr := &a
	t.Log(a, aPtr)
	t.Logf("%T %T", a, aPtr)
}

func TestString(t *testing.T) {
	// 不赋值默认空字符串
	var s string
	t.Log("*" + s + "*")
	t.Log(len(s))
	t.Log(s == "")
}

func TestMax(t *testing.T) {
	t.Log(math.MaxFloat64)
	t.Log(math.MaxInt64)
}
