package map_test

import (
	"testing"
)

// map的声明
func TestMapInit(t *testing.T) {
	m1 := map[string]int{"a": 1, "b": 2, "c": 3}
	t.Log(m1["b"])
	t.Logf("len m1=%d", len(m1))

	m2 := map[string]int{}
	m2["d"] = 4
	t.Logf("len m2=%d", len(m2))
	m3 := make(map[string]int, 10)
	t.Logf("len m3=%d", len(m3))
}

// map判断键key是否存在
func TestAccessNotExistingKey(t *testing.T) {
	m1 := map[int]int{}
	// 不存在会默认为0 而不是nil
	t.Log(m1[1])
	m1[2] = 0
	t.Log(m1[2])

	if v, ok := m1[3]; ok {
		t.Logf("Key 3 value is %d", v)
	} else {
		t.Log("Key 3 is not exist")
	}

	// 赋值后
	m1[3] = 0
	if v, ok := m1[3]; ok {
		t.Logf("Key 3 value is %d", v)
	} else {
		t.Log("Key 3 is not exist")
	}

}

// 遍历Map
func TestTravelMap(t *testing.T) {
	m1 := map[string]int{"a": 1, "b": 2, "c": 3}
	for k, v := range m1 {
		t.Logf("Key: %s, Value: %d", k, v)
	}
}
