package map_ext

import (
	"fmt"
	"testing"
)

// 值为方法的map
func TestMapWithFunValue(t *testing.T) {
	m := map[int]func(op int) int{}
	m[1] = func(op int) int { return op }
	m[2] = func(op int) int { return op * op }
	m[3] = func(op int) int { return op + op + op }
	t.Log(m[1](2), m[2](2), m[3](2))
}

// Map实现Set操作
func TestMapForSet(t *testing.T) {
	mySet := map[int]bool{}

	// 添加元素
	mySet[1] = true
	mySet[2] = false
	t.Logf("set len=%d", len(mySet))

	// 判断元素是否存在
	n := 3
	if mySet[n] {
		t.Logf("%d is exist", n)
	} else {
		t.Logf("%d is not exist", n)
	}

	//删除元素
	delete(mySet, 1)
	ValueIsExit(mySet, 1)

}

func ValueIsExit(s map[int]bool, v int) bool {
	if s[v] {
		fmt.Printf("%d is exist", v)
		return true
	} else {
		fmt.Printf("%d is not exist", v)
		return false
	}
}
